;; Copyright 2009, 2015 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(progn
  (add-to-list 'load-path "~/lisp")
  (autoload 'html-smarter-href-anchor "html-smarter-href-anchor" nil t))

(add-hook 'html-smarter-href-anchor-mode-hook 'turn-on-font-lock)

(customize-group 'html-smarter-href-anchor)

(setq html-smarter-href-anchor-website-root "/var/www")
(html-smarter-href-anchor)

(html-smarter-href-anchor-override)
(html-href-anchor)

/var/www/ru


;;-----------------------------------------------------------------------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------------------------------------------------------------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "~/lisp/html-smarter-href-anchor.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))









(defcustom html-smarter-href-anchor-add-file nil
  "Make path /foo/bar expand to file:///foo/bar.
If t then `html-smarter-href-anchor' adds \"file:///...\" to a
path beginning with \"/\", as for a local filename and expands it
to .  The default is nil which means leave such a path alone.

In a page for a web site you'll want paths left alone but when
editing a personal browser startup page it's helpful to have say
/usr/share/something/manual.html get a file:// added for a link
to locally installed docs."
  :type 'boolean
  :group 'html-smarter-href-anchor)

* If `html-smarter-href-anchor-add-file' is true then a path
  starting \"/\" expands to \"file://\" for a local file.  (See
  that variable for more.)

            ((and html-smarter-href-anchor-add-file
                  (string-match "\\`/[^.]+/" str))    ;; /usr/foo/bar
             (setq str (concat "file://" str)))
