;; Copyright 2016 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------

(defun my-filename-to-wip (filename)
  (let* ((dir      (file-name-directory filename))
         (basename (file-name-nondirectory filename))
         (lisp-dir "~/lisp")
         (wip-dir  (expand-file-name "wip" dir)))
    (cond ((file-exists-p (expand-file-name basename lisp-dir))
           (expand-file-name basename lisp-dir))
          ((file-exists-p (expand-file-name basename wip-dir))
           (expand-file-name basename wip-dir))
          (t
           filename))))
(my-filename-to-wip "~/p/el/align-let.el")

(let ((file-list (append (directory-files "~/p/el"      t "\\.el\\'")
                         (directory-files "~/p/ac"      t "\\.el\\'")
                         (directory-files "~/p/aumix"   t "\\.el\\'")
                         (directory-files "~/p/fsl"     t "\\.el\\'")
                         (directory-files "~/p/gin"     t "\\.el\\'")
                         (directory-files "~/p/pcf2bdf" t "\\.el\\'")
                         (directory-files "~/p/tcd"     t "\\.el\\'")
                         (directory-files "~/p/weblint" t "\\.el\\'")
                         (directory-files "~/p/xtide"   t "\\.el\\'"))))
  (setq file-list (mapcar 'my-filename-to-wip file-list))
  (load "my-byte-compile.el")
  (dolist (filename file-list)
    (message "%s" filename)
    (byte-compile-file filename)))


(add-hook 'emacs-lisp-mode-hook
          (lambda ()
            (message "lexical-binding for %s" buffer-file-name)
            (setq lexical-binding t)))



