;;; t-pst-format.el --- development testing pst-format.el

;; Copyright 2008, 2009, 2010, 2014 Kevin Ryde

;; t-pst-format.el is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; t-pst-format.el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'pst-format))

(progn
  (add-to-list 'load-path (expand-file-name "../wip"))
  (require 'pst-format)
  (modify-coding-system-alist 'file "\\.pst0\\'" 'raw-text-unix)
  (find-file "d-pst-format.pst0"))

(progn
  (add-to-list 'load-path (expand-file-name "../wip"))
  (require 'pst-format)
  (setq file-coding-system-alist
        (remove '("\\.pst0\\'" raw-text-unix . raw-text-unix)
                file-coding-system-alist))
  (find-file "d-pst-format.pst0"))

(modify-coding-system-alist 'file "\\.pst0\\'" 'raw-text-unix)
(modify-coding-system-alist 'file "\\.pst0\\'" 'no-conversion)
(modify-coding-system-alist 'file "\\.pst0\\'" 'iso-8859-1)

(add-to-list 'auto-mode-alist '("\\.pst0\\'" . cperl-mode))

(find-file "d-pst-format.pst0")
(find-file "~/.dh-make-perl/Contents.cache")
(find-file "d-pst-format-zzz.txt")

(find-file-literally "d-pst-format.pst0")

enable-multibyte-characters
(set-buffer-multibyte t)
(require 'un-define)

;;-----------------------------------------------------------------------------
;; with no default-directory

(let ((pstfile (expand-file-name "d-pst-format.pst0")))
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'pst-format)

  (switch-to-buffer "*t-pst-format--test*")
  (kill-buffer "*t-pst-format--test*")
  (switch-to-buffer "*t-pst-format--test*")

  (setq default-directory "/no/such/directory/")
  (insert-file-literally pstfile)
  (format-decode-buffer 'pst-format))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;-----------------------------------------------------------------------------
(let ((elfile (expand-file-name "../pst-format.el"))
      (tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads elfile)
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))

;;-----------------------------------------------------------------------------
(progn
  (pst-format-set-buffer-multibyte nil)
  (let ((coding-system-for-write buffer-file-coding-system)
        (coding-system-for-read  'utf-8)
        (process-connection-type nil)) ;; pipe
    (call-process-region
     (point-min) (point-max)
     "cat"
     t                 ;; delete old
     (list t           ;; stdout here
           "/tmp/err") ;; stderr to file
     nil               ;; no redisplay
     "/tmp/dot"))
  (pst-format-set-buffer-multibyte t))
