;; Copyright 2013, 2014 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

;;-----------------------------------------------------------------------------
(autoload 'foo "filename" "Foo docstring" t)
(documentation 'foo)

;;-----------------------------------------------------------------------------

(load "upstr.el")
(interactive-form 'upstr-up-list-or-string)
(symbol-function 'upstr-up-list-or-string)

(defun foo ()
  (interactive "&&&")
  123)

(foo (bar "(quux (xyzzy (blah))"))

;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

(progn
  (byte-compile-file "upstr.el")
  (find-file "upstr.elc")
  (delete-file "upstr.elc"))

;;-----------------------------------------------------------------------------

(defun backward-up-list-or-string (arg)
  "Move point up outside a list or string.
If point is within a string then move to the start of the string
just before its opening \" etc.  If not then move up as per
`backward-up-list'.

Optional ARG is how many levels to move up.  If within a string
then that counts as one level."

  (interactive "^p")
  (let ((state (syntax-ppss)))
    (when (nth 3 state) ;; within string
      (goto-char (nth 8 state)) ;; start of string
      (setq arg (1- arg))))
  (backward-up-list arg))



;;-----------------------------------------------------------------------------
(tex-mode)


(modify-syntax-entry ?$ "$$" (syntax-table))

(
{
  "string  $$ te foo $$ jdks  "
  fjsk
  $ x
}

(1 3 8 nil nil nil 0 nil nil (3))
(goto-char (or (upstr-math-start-position) (point)))







;;-----------------------------------------------------------------------------

;; ;;;###autoload
;; (defun upstr-keybindings ()
;;   (interactive)
;;   (when (fboundp 'syntax-ppss)
;;     (global-set-key [remap up-list]          'upstr-up-list-or-string)
;;     (global-set-key [remap backward-up-list] 'upstr-backward-up-list-or-string)))


"(blah
