;; Copyright 2016 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(defun byte-compile-quoted-symbol (form)
  "If FORM is a list (quote foo) return symbol foo, otherwise return nil."
  (and (eq 'quote (car-safe form))
       (symbolp (car-safe (cdr form)))
       (null (cddr form))
       (cadr form)))




(progn
  (defconst my-const 456)
  (defun foo ()
    (setq-default my-const 123))
  (byte-compile 'foo))
(byte-compile-file "d-bytecomp-add-to-list-2.el")

    '(add-to-list 'xyz 123)
(disassemble 'foo)



(let (lst)
  (mapatoms (lambda (symbol)
              (if (fboundp symbol)
                  (let ((func (symbol-function symbol)))
                    (if (subrp func)
                        (push symbol lst))))))
  (setq lst (mapcar 'symbol-name lst))
  (setq lst (sort lst 'string-lessp))
  (dolist (str lst)
    (insert (format "%S\n" str))))
